# uoTES.js - RPGツクールMV用プラグイン
uoTES.jsのRPGツクールMV用プラグインです。  
ツクールMV上でコンパイル済のTESイベントファイルを読み込み、利用できるようになります。

## uoTES.jsについて
下記リンクを参照してください。  
https://github.com/RaTTiE/uotes-core

## 使い方
uoTESEvent.jsを導入対象プロジェクトのjs/pluginsフォルダへコピーし、プラグインを有効化してください。  

### 注釈文からのリンクについて  
プラグイン導入後、コンパイル済TESイベントをイベント注釈文、またはプラグインコマンドから実行することができます。  

注釈文からTESイベントを実行する場合、注釈文にリンクタグを記述します。  
リンクタグにはリンク対象のファイル名(拡張子は省略)とリンク先のラベルを指定します。  
リンク先のラベルを省略した場合、イベントはファイルの先頭から実行されます。  

下記の記述の場合、test.jsonを呼び出して先頭から実行します。  

```
注釈:test.jsonの先頭にリンクします。
    :<link test>
```

下記のようにラベルを明示した場合、イベントファイルの中からラベルを検索し、指定したラベルからイベントが実行されます。

```
注釈:opening.jsonのラベル「２周目」にリンクします。
    :<link opening ２周目>
```

### パッチ機能について
このプラグインは、TESイベントファイルの差分配布用にパッチ機能を実装しています。  
パッチ機能は、ツクール実行ファイルから起動するオフラインモード時のみ有効となります。  
ブラウザ実行等のオンラインで配布しているゲームではパッチ機能を利用できないため、アップロードしているサーバに対して直接更新を行ってください。  

uoTESのパッチは、パッチ対象のイベントファイルを格納した「patch[パッチ番号]」というフォルダになります。  
パッチファイルが存在する場合、イベントファイルのロード時に同名ファイルがあれば代わりにロードされます。  
また、複数のパッチファイルが存在する場合はより大きなパッチ番号のパッチファイルがロードされます。  

#### 注意
- パッチ機能有効時、悪意のあるファイルにより予期されないイベントが実行される可能性があります。
- パッチ機能の有効状態はプラグインのパラメータから設定するため、パッチ機能を利用する場合は事前に設定をオンにした状態でゲームを配布する必要があります。

### パラメータ
- Main Dir  
  TESイベントファイルの格納先です(デフォルト値:"./data/tes/")。  
  変換したTESイベントファイルはこのフォルダへ格納してください。
- Patch Dir  
  TESイベントパッチファイルの格納先です(デフォルト値:"./tespatch/")。  
  配布するパッチファイルはこのフォルダへ格納するようユーザへ指示してください。
- Patch Enable  
  パッチ機能の有効状態です。この機能はオフラインモード時のみ有効です(デフォルト値: false)。

### プラグインコマンド
- uoTESEvent link filename [label]  
  TESイベントをロードし、イベントの実行を行います。  
  ラベルを指定した場合、指定したラベルから実行します。
- uoTESEvent preload filename  
  TESイベントを事前ロードし、内部キャッシュへと格納します。
- uoTESEvent release [filename]  
  TESイベントを内部キャッシュから削除します。
  ファイル名を省略した場合、内部キャッシュを全てクリアします。

## ライセンス
The MIT License (MIT)
